/*
 *	xalien.h	97/01/26 by oga.
 *
 */

#include <unistd.h>
#include <sys/time.h>

/* 
 *  misc define 
 */
#define BASE		(46*2+2)		/* x=0,y=0mapʒu       */
#define	X2X(x)		(x)*CSIZ/2+CSIZ		/* x  pixel Xʒuɕϊ */
#define	Y2Y(y)		(y)*CSIZ/2+CSIZ*3       /* y  pixel Yʒuɕϊ */
#define IS_BLOCK(s)	((s.x & 1) || (s.y & 1)) 


/*
 *  color code define
 */
#define BLACK	0
#define BLUE	1
#define RED	2
#define MAGENTA	3
#define GREEN	4
#define CYAN	5
#define YELLOW	6
#define WHITE	7
#define COL8 	8
#define COL9	9
#define COL10	10
#define COL11	11
#define COL12	12
#define COL13	13
#define COL14	14
#define COL15	15

#define COLORS	16	/* number of colors */

#define CSIZ	16

/* 
 *  character number define
 */
#define SPACE	0
#define KEVA0	1
#define KEVA1	2
#define KEVA2	3
#define KEVA3	4
#define KEVB0	5
#define KEVB1	6
#define KEVB2	7
#define KEVB3	8
#define KEVC0	9
#define KEVC1	10
#define KEVC2	11
#define KEVC3	12
#define PAKU0	13
#define PAKU1	14
#define PAKU2	15
#define PAKU3	16
#define ANA1	17
#define ANA2	18
#define ANA3	19
#define ANA4	20
#define ANA5	21
#define UME1	22
#define UME2	23
#define UME3	24
#define UME4	25
#define ZUBO0	26
#define ZUBO1	27
#define ALIEN0	28
#define ALIEN1	29
#define ALIEN2	30
#define ALIEN3	31
#define KABE	32

#define PICS	33	/* number of pictures */

/* 
 *  charcter vector define / keycode
 */
#define UP	0
#define DOWN	1
#define LEFT	2
#define RIGHT	3
#define NOMOVE	4

#define DIG	5
#define DUG	6
#define START	7


/* 
 *  function define
 */
/* xalien.c */
extern void pix_init();
extern void init_kevi();
extern void init_alien();
extern void put_maze();
extern void make_map();
extern void map_fill_rect();
extern void update_xy();
extern void get_rnd_pos();
extern void kev_die_newpos();
extern void kev_rest_disp();
extern void score_disp();
extern void redraw();
extern void AddOneAlien();
extern void GetHighScore();
extern void SaveHighScore();

/* putcahr.c */
extern void CLEAR_CHAR();
extern void PUT_CHAR();
extern void PUT_ALIEN();
extern void PUT_KEV();
extern void PUT_PAKU();


/*
 *   structs
 */

/* ALIEN */
typedef struct alian {
	int  x;		/* position X                 */
	int  y;		/* position Y                 */
	int  vec;	/* move vector                */
	int  die;	/* alive status 0:alive 1:die */
	int  cnt;	/* intersection skip count    */
	int  stop;	/* stop flag (in small hole)  */
	int  ana;	/* drop hole pattern code     */
	int  dropcnt;   /* drop cnt for char change   */
	struct timeval droptv;	/* drop time          */
} al_t;

/* g */
typedef struct kebiishi {
	int  x;			/* position X         */
	int  y;			/* position Y         */
	int  vec;		/* move vector        */
	int  rest;		/* rest of keviishi   */
	int  score;		/* score              */
	int  upf;		/* exeted done flag   */
	int  digchar;		/* digchar flag  V1.02*/
	struct timeval digtv;	/* last dig tv        */
} kv_t;

/*  */
typedef struct ana {
	int  x;		/* position X                 */
	int  y;		/* position Y                 */
	int  stat;	/* hole status                */
} ana_t;

/*
 *   maze data
 */
static char maze[8][9*11] = {{	1,0,1,0,1,0,1,1,1,	/* MAZE1 */
 		       		0,0,1,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,1,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,1,1,0,1,0,1,0,1,
		       		1,0,0,0,0,0,1,0,0,
		       		1,0,1,0,1,0,1,1,1,
		       		0,0,0,0,1,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1  },

	              	     {  1,0,1,1,1,0,1,1,1,	/* MAZE2 */
		       		0,0,0,0,0,0,0,0,0,
		       		1,1,1,0,1,1,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,1,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,1,1,0,1,
		       		1,0,0,0,0,0,1,0,0,
		       		1,0,1,0,1,0,1,0,1  },

	              	     {  1,0,1,0,1,0,1,0,1,	/* MAZE3 */
		       		0,0,0,0,1,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		1,0,0,0,0,0,0,0,1,
		       		1,0,1,1,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,1,1,
		       		1,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,1,0,0,
		       		1,1,1,0,1,0,1,0,1  },

	              	     {  1,0,1,0,1,0,1,0,1,	/* MAZE4 */
		       		0,0,0,0,0,0,1,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,1,1,0,1,0,1,1,1,
		       		1,0,0,0,0,0,0,0,0,
		       		1,0,1,1,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,1,1,0,1,
		       		0,0,1,0,0,0,0,0,0,
		       		1,1,1,0,1,0,1,0,1  },

	              	     {  1,0,1,1,1,0,1,0,1,	/* MAZE5 */
		       		0,0,0,0,0,0,1,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,1,1,0,1,
		       		0,0,1,0,0,0,0,0,1,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		1,0,0,0,0,0,0,0,0,
		       		1,1,1,0,1,1,1,0,1  },

	              	     {  1,0,1,0,1,1,1,0,1,	/* MAZE6 */
		       		0,0,0,0,0,0,1,0,0,
		       		1,0,1,1,1,0,1,1,1,
		       		1,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,1,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,1,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,1,
		       		1,0,1,0,1,0,1,0,1  },

	              	     {  1,0,1,1,1,0,1,0,1,	/* MAZE7 */
		       		0,0,0,0,1,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,1,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,1,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,1,0,1,0,0,
		       		1,0,1,0,1,0,1,0,1  },

	              	     {  1,0,1,0,1,0,1,0,1,	/* MAZE8 */
		       		0,0,0,0,0,0,0,0,0,      /* not active */
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1,
		       		0,0,0,0,0,0,0,0,0,
		       		1,0,1,0,1,0,1,0,1  }};

